<template>
  <modal name="modal-payment-order"
         class="arcticmodal-container full-viewport"
         :height="'auto'"
         :adaptive="true"
         @before-open="beforeOpen"
         @before-close="beforeClose">
    <div class="pay-order-modal">
      <div class="container m-header">
        <div
          @click="close()"
          class="box-modal_close arcticmodal-close"></div>
        <div class="row">
          <div class="column">
            <h3>ПОРЯДОК ОПЛАТЫ</h3>
          </div>
        </div>
      </div>
      <div class="container">
        <div class="text">Сумма платежа будет зачислена в следующей последовательности:</div>
        <div class="pay-order">
          <div class="table-header">
            <div class="row">
              <div class="column one">
                №
              </div>
              <div class="columns six">
                Назначение
              </div>
              <div class="columns three">
                Сумма
              </div>
              <div class="columns two">
              </div>
            </div>
          </div>
          <ajax-loader v-if="!orderedContracts"></ajax-loader>
          <div v-for="(contract, index) in orderedContracts" class="row table-row">
            <div class="column one">
              <span class="adaptive">Очередность:</span> {{index + 1}}.
            </div>
            <div class="columns six"><span class="adaptive">Назначение:</span> Займ {{contract.orderNumber}} ({{contract.typeText}})</div>
            <div class="columns three"><span class="adaptive">Сумма:</span> <strong>{{contract.sum}} ₽</strong></div>
            <div class="columns two adaptive-right" v-if="contract.type !== 2">
              <span v-show="index !== orderedContracts.length - 1" @click="changeOrder(orderedContracts, index, index+1)" href="#" class="status-down" title="На позицию ниже"><span
                class="adaptive"> На позицию ниже</span></span>
              <span v-show="index !== 0" @click="changeOrder(orderedContracts, index, index-1)" href="#" class="status-up" title="На позицию выше"><span
                class="adaptive"> На позицию выше</span></span>
            </div>
          </div>
        </div>
        <div class="nota-bene">Вы можете изменить порядок оплаты нажимая на значки стрелочки</div>
        <div class="center">
          <button @click="submit">Сохранить</button>
        </div>
      </div>
    </div>
  </modal>
</template>
<script>
  import invoke from 'lodash/invoke'
  import {SET_PAYMENT_ORDER} from '@/store/mutation-types'
// import {getPayOrder} from '@/utils/api'
// import {loanTypeMapper} from '@/utils/mappings/loans'

export default {
    name: 'modal-payment-order',
    data () {
      return {
        contracts: null,
        time: 0,
        duration: 5000,
        params: {}
      }
    },
    computed: {
      orderedContracts: {
        get () {
          return this.contracts || this.$store.getters.getPaymentOrder
        },
        set (newContracts) {
          this.contracts = newContracts
        }
      }
    },
    methods: {
      async beforeOpen (event) {
        this.params = event.params
        this.$helpers.noscroll(true)
      },

        beforeClose() {
            this.$helpers.noscroll(false)

        },

      close () {
        invoke(this, 'params.onClose')
        this.$modal.hide('modal-payment-order')
        this.$helpers.noscroll(false)
      },
      changeOrder (arr, first, second) {
        /**
         * доп.соглашение всегда должно идти первым. менять порядок нельзя.
         */
        if (arr[second].type === 2) {
          return false;
        }
        [arr[first], arr[second]] = [arr[second], arr[first]]
        this.orderedContracts = [...arr]
      },
      submit () {
        this.contracts && this.$store.commit(SET_PAYMENT_ORDER, this.contracts)
        this.close()
      }
    }
  }
</script>
<style scoped>
  h3 {
    margin-bottom: 0px !important;
  }
  .buttons {
    text-align: center
  }
</style>
